package com.bocloud.mcs.aspect;

import java.lang.annotation.*;

/**
 * 开启采集控制
 *
 * @author lym
 * @since 2022/07/18
 */
@Documented
@Target({ElementType.TYPE, ElementType.METHOD})
@Retention(RetentionPolicy.RUNTIME)
public @interface EnableCollector {

    String value() default "true";

    /**
     * 是否支持切片，如果不支持，则只允许主节点执行
     *
     * @return 是否支持切片
     */
    boolean section() default false;
}
