package com.bocloud.mcs.collector.kvm;

import com.bocloud.mcs.aspect.EnableCollector;
import com.bocloud.mcs.collector.BocloudCollector;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.ApplicationContext;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * 服务操作业务实现
 *
 * @author YuFengYang
 * @version 1.0
 * @since 2023/1/12 14:57
 */

@Component
@Slf4j
public class KvmHostCollector extends BocloudCollector {


    @Autowired
    private ApplicationContext applicationContext;

    @Value("${collector.kvm.thread.number:20}")
    private Integer threadNumber;

    @Override
    public List<MetricFamilySamples> collect() {
        return super.collect();
    }

    @Async
    @Override
    @EnableCollector(value = "${collector.kvm.host.enable:true}")
    @Scheduled(initialDelay = 1000L, fixedRate = 60000)
    public void scheduledCollect() {
//        log.info("collect kvm host metrics start...");
//        GaugeMetricFamily collectTimeUse = new GaugeMetricFamily("kvm_"_HOST + "collect_time_use", "help",
//                Arrays.asList("type"));
//        ExecutorService executors = Executors.newFixedThreadPool(threadNumber);
//        Date now = new Date();
//        List<Collector.MetricFamilySamples> mfs = new ArrayList<>();
//        List<Collector.MetricFamilySamples> list = new ArrayList<>();
//        List<CloudVendor> vendors = cmpCloudVendorService.list(CloudProvider.KVM);
//        List<KvmHost> hosts = new ArrayList<>();
//        for (CloudVendor vendor : vendors) {
//            List<KvmHost> kvmHosts = cmpCloudVendorService.listKvmHost(vendor.getId());
//            hosts.addAll(kvmHosts);
//        }
//        List<String> labels = Arrays.asList("host_cloud", "host_id");
//        for (KvmHost host : hosts) {
//            executors.submit(() -> {
//                Connect connect = null;
//                try {
//                    connect = new Connect(host.getUri(), true);
//
////                    int vir_node_cpu_stats_user = connect.NodeGetCPUStats(8, "VIR_NODE_CPU_STATS_USER", 0, 0);
////                    log.info("---------------------------->{}",vir_node_cpu_stats_user);
////
//
//                    NodeInfo nodeInfo = connect.nodeInfo();
//                    long freeMemory = connect.getFreeMemory();
//                    long memoryTotal = connect.nodeInfo().memory * 1024;
//                    int cpus = nodeInfo.cpus;
//                    GaugeMetricFamily memoryFreeData = new GaugeMetricFamily("kvm_"_HOST + "memory_free", "help",
//                            labels);
//                    GaugeMetricFamily memoryTotalData = new GaugeMetricFamily("kvm_"_HOST + "memory_total", "help",
//                            labels);
//                    GaugeMetricFamily cpuNumData = new GaugeMetricFamily("kvm_"_HOST + "info_virtual_cpus", "help",
//                            labels);
//
//
//                    memoryFreeData.addMetric(Arrays.asList(host.getVendorId() + "", host.getId() + ""), freeMemory);
//                    memoryTotalData.addMetric(Arrays.asList(host.getVendorId() + "", host.getId() + ""), memoryTotal);
//                    cpuNumData.addMetric(Arrays.asList(host.getVendorId() + "", host.getId() + ""), cpus);
//
//                    list.add(memoryFreeData);
//                    list.add(memoryTotalData);
//                    list.add(cpuNumData);
//                } catch (Exception e) {
//                    log.error("collect node metrics error!" + e.getMessage(), e);
//                } finally {
//                    if (connect != null) {
//                        try {
//                            connect.close();
//                        } catch (LibvirtException e) {
//                            log.error("连接关闭异常 {}", e);
//                        }
//                    }
//                }
//            });
//        }
//        executors.shutdown();
//        try {
//            executors.awaitTermination(5, TimeUnit.MINUTES);
//        } catch (InterruptedException e) {
//            log.error("kvm not complete within its interval", e);
//            Thread.currentThread().interrupt();
//        }
//        mfs.addAll(list);
//        collectTimeUse.addMetric(Arrays.asList("instance"), (System.currentTimeMillis() - now.getTime()));
//        mfs.add(collectTimeUse);
//        super.getCache().put(TIME, new Date());
//        super.getCache().put(DATA, mfs);
//        log.info("collect kvm vm metrics end! use " + (System.currentTimeMillis() - now.getTime()) / 1000 + "s");
    }

}

