package com.bocloud.mcs.collector.manageone.cce.common;

import com.alibaba.fastjson.JSONObject;
import com.megatron.common.enums.PostDataFormat;
import com.megatron.common.http.HttpClient;
import com.megatron.common.model.Result;

import java.util.Map;

/**
 * @author fanzx
 * @create 2021/10/12 11:53
 */
public class ManageOneCommon {

    private HttpClient client;
    private static final Integer TIMEOUT = 20 * 60 * 1000;


    /**
     * post用户登录功能 用于获取token
     * @param url   调用url
     * @param header 请求头 固定
     * @param params 请求body -> username and password
     * @return
     */
    public JSONObject post(String url, Map<String, Object> header, Map<String, Object> params) {
        this.client = new HttpClient(TIMEOUT, PostDataFormat.RAW);
        try {
            client.setDataFormat(PostDataFormat.RAW);
            Result result = this.client.post(header, params, url);
            client.close();
            String message = result.getMessage();
            return JSONObject.parseObject(message);
        } finally {
            this.client.close();
        }
    }

    /**
     * 获取监控数据
     * @param url
     * @param header
     * @param params
     * @return
     */
    public JSONObject get(String url, Map<String, Object> header, Map<String, Object> params) {
        client = new HttpClient(TIMEOUT, PostDataFormat.RAW);
        try {
            client.setDataFormat(null);
            Result  result = client.get(header, params, url);
            client.close();
            return JSONObject.parseObject(result.getMessage());
        } finally {
            client.close();
        }
    }

    public JSONObject put(String url, Map<String, Object> header, Map<String, Object> params) {
        client = new HttpClient(TIMEOUT, PostDataFormat.RAW);
        try {
            Result  result = client.put(header, params, url);
            client.close();
            return JSONObject.parseObject(result.getMessage());
        } finally {
            client.close();
        }
    }

}
