package com.bocloud.mcs.collector.manageone.cce.common;


import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@AllArgsConstructor
@NoArgsConstructor
public class ManagerMonitorEntity {

    /**
     * {
     *     "errorCode":"SVCSTG_AMS_2000000",
     *     "errorMessage":"success",
     *     "metrics":[
     *         {
     *             "metric":{
     *                 "namespace":"abc",
     *                 "metricName":"def",
     *                 "dimensions":[
     *                     {
     *                         "name":"ghi",
     *                         "value":"lmn"
     *                     }
     *                 ]
     *             },
     *             "dataPoints":[
     *                 {
     *                     "timestamp":"1467892800000",
     *                     "unit":"Percent",
     *                     "statistics":[
     *                         {
     *                             "statistic":"maximum",
     *                             "value":"23"
     *                         }
     *                     ]
     *                 }
     *             ]
     *         }
     *     ]
     * }
     */

    private String errorCode;
    private String errorMessage;
    private List<Metrics> metrics;

    @Data
    @AllArgsConstructor
    @NoArgsConstructor
    public static class Metrics{
        private Metric metric;
        private List<DataPoints> dataPoints;
    }
    @Data
    @AllArgsConstructor
    @NoArgsConstructor
    public static class Metric{
        private String namespace;
        private String metricName;
        private List<Dimensions> dimensions;
    }
    @Data
    @AllArgsConstructor
    @NoArgsConstructor
    public static class Dimensions{
        private String name;
        private String value;
    }
    @Data
    @AllArgsConstructor
    @NoArgsConstructor
    public static class DataPoints{
        private String timestamp;
        private String unit;
        private List<Statistics> statistics;
    }
    @Data
    @AllArgsConstructor
    @NoArgsConstructor
    public static class Statistics{
        private String statistic;
        private String value;
    }
}
