package com.bocloud.mcs.config;

import com.moandjiezana.toml.Toml;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.io.File;
import java.io.InputStream;

/**
 * @author zhangyf
 */
@Slf4j
@Configuration
public class CollectorConfiguration {

    @Value("${collector.config:}")
    private String collectorConfigPath;

    @Bean
    public Toml collectorConfig() {
        if (StringUtils.isBlank(collectorConfigPath)) {
            try (InputStream inputStream = this.getClass().getResourceAsStream("/collector.conf")) {
                return new Toml().read(inputStream);
            } catch (Exception e) {
                log.error("load collector.conf failed!", e);
                return null;
            }
        }
        return new Toml().read(new File(collectorConfigPath));
    }
}
