package com.bocloud.mcs.service.internal;

import com.bocloud.cmp.boot.model.BoCloudService;
import com.bocloud.cmp.boot.model.BocloudToken;
import com.megatron.common.model.GeneralResult;
import com.megatron.framework.core.CurrentService;
import com.megatron.framework.core.Service;
import com.megatron.framework.http.core.HttpMethod;
import com.megatron.framework.http.core.ServiceFactory;
import com.megatron.framework.http.model.RemoteService;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

@Component
public class CmsCloudVendorService {

    private final ServiceFactory serviceFactory;
    private final CurrentService currentService;

    public CmsCloudVendorService(ServiceFactory serviceFactory, CurrentService currentService) {
        this.serviceFactory = serviceFactory;
        this.currentService = currentService;
    }

    /**
     * 查询平台的运维账号信息（仅FusionCloud适用）
     *
     * @return
     */
    public GeneralResult detailVendorAuth(Long vendorId) {
        Map<String, Object> headers = new HashMap<>(4);
        headers.put(BocloudToken.INTERNAL_TOKEN, currentService.getToken());

        String url = "/v1/vendors/" + vendorId + "/authentications";
        RemoteService remoteService = serviceFactory.build(Service.create(String.valueOf(BoCloudService.CMS.getName())), url, HttpMethod.GET, headers, null);
        return remoteService.invoke();
    }


    /**
     * 查询已开启监控的FC平台
     * @return
     */
    public GeneralResult listFC() {
        Map<String, Object> headers = new HashMap<>(4);
        headers.put(BocloudToken.INTERNAL_TOKEN, currentService.getToken());
        RemoteService remoteService = serviceFactory.build(Service.create(String.valueOf(BoCloudService.CMS.getName())), "/v1/vendors/authentications", HttpMethod.GET, headers,
                new HashMap<>());
        return remoteService.invoke();
    }

}
