package com.bocloud.mcs.service.internal;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.boot.model.BoCloudService;
import com.bocloud.cmp.boot.model.BocloudToken;
import com.bocloud.mcs.collector.manageone.cce.common.ContainerCluster;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.Pager;
import com.megatron.common.model.Param;
import com.megatron.common.utils.Common;
import com.megatron.common.utils.MapTools;
import com.megatron.framework.core.CurrentService;
import com.megatron.framework.core.Service;
import com.megatron.framework.http.core.ServiceFactory;
import com.megatron.framework.http.model.RemoteService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.Assert;
import com.megatron.framework.http.core.HttpMethod;
import com.megatron.common.model.Sign;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


@Component
public class ImsCloudServerService {

    @Autowired
    private ServiceFactory serviceFactory;
    @Autowired
    private CurrentService currentService;

    /**
     * 列表查询
     *
     * @param pager
     * @param token 如果为null，则使用internal_token内部调用查询
     * @return
     */
    public GeneralResult list(Pager pager, String token) {
        Map<String, Object> headers = new HashMap<>(4);
        if (token == null) {
            headers.put(BocloudToken.INTERNAL_TOKEN, currentService.getToken());
        } else {
            headers.put(Common.TOKEN, token);
        }
        RemoteService remoteService = serviceFactory.build(Service.create(String.valueOf(BoCloudService.CMP.getName())), "/v1/vms", HttpMethod.GET, headers, pager.toMap(false));
        return remoteService.invoke();
    }

    public List<ContainerCluster> getCceContainer(Long  vendorId) {
        Map<String, Object> headers = new HashMap<>(4);
        headers.put(BocloudToken.INTERNAL_TOKEN, currentService.getToken());

        List<Param> paramList = new ArrayList<>();
        paramList.add(new Param(MapTools.simpleMap("vendorId", vendorId), Sign.EQ));
        RemoteService remoteService = serviceFactory.build(Service.create(String.valueOf(BoCloudService.CMP.getName())),
                "/plugins/manageone/v1/containers/clusters", HttpMethod.GET, headers, new Pager(1, Integer.MAX_VALUE, paramList, null).toMap(false));
        GeneralResult<?> result = remoteService.invoke();
        Assert.isTrue(result.isSuccess(), "list manager bms failed, error:" + result.getMessage());
        JSONObject data = (JSONObject) result.getData();
        return data.getJSONArray(Common.ROWS).toJavaList(ContainerCluster.class);
    }

}
